//*****************************************
// Photo Box with ATmega64 or Atmega2560
// CPU Clock:O16MHz Ext,Crystal 16MHz)
//   iq[Yf[^@WȂŊOUɂj
//
// File Name:Rtc_Rx8900.c
//
//  PC5(SCL): TWI-SCL
//  PC4(SDA): TWI-SDA
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2012/11/12 New Taishi
//  2023/05/16 Modify for mega328_iic_oled_rtc Taishi
//  2023/12/09 Modify for Photo Box with ATmega64 Taishi
//  2024/01/09 Modify for Photo Box with ATmega64 or ATmega2560 Taishi
//*****************************************

#include	<avr/interrupt.h>
#include	<avr/io.h>
#include	<compat/twi.h>
#include	<avr/pgmspace.h>

#include	"pr_mega64_2560_photo_box_h.h"

#include	"mega_twi_h.h"
#include	"timer_h.h"
#include	"port_bit_h.h"

#include	"Rtc_Rx8900_h.h"


volatile unsigned char	gRTC_sec;				// qsb b̃f[^ (BCD 0--59)
volatile unsigned char	gRTC_min;				// qsb ̃f[^ (BCD 0--59)
volatile unsigned char	gRTC_hou;				// qsb ̃f[^ (BCD 0--23j
volatile unsigned char	gRTC_wday;				// qsb j̃f[^ (BCD 1--7)
volatile unsigned char	gRTC_day;				// qsb ̃f[^ (BCD 1--31)
volatile unsigned char	gRTC_mon;				// qsb ̃f[^ (BCD 1--12j
volatile unsigned char	gRTC_year;				// qsb Ñf[^ (BCD 0--99)
volatile unsigned char	gRTC_control1;			// qsb Rg[P̃f[^
volatile unsigned char	gRTC_control2;			// qsb Rg[Q̃f[^
volatile unsigned char	gRTC_control1_first;	// qsb Nŏ̃Rg[P̃f[^
volatile unsigned char	gRTC_control2_first;	// qsb Nŏ̃Rg[Q̃f[^
volatile unsigned char	gRTC_reg[16];			// SẴWX^̒l
volatile unsigned char	gRTC_extension;;		// RTC GNXeV WX^
volatile unsigned char	gRTC_flag;				// RTC tO
volatile unsigned char	gRTC_control;			// RTC Rg[f[^
volatile unsigned char	gRTC_tempe;				// RTC xf[^
volatile unsigned char	gRTC_buckup;			// RTC obNAbvf[^
volatile unsigned char	gRTC_timer_count0;		// RTC ^C}[JE^[O
volatile unsigned char	gRTC_timer_count1;		// RTC ^C}[JE^[P
volatile unsigned char	gRTC_alarm_min;			// RTC A[ lhm
volatile unsigned char	gRTC_alarm_hou;			// RTC A[ gntq
volatile unsigned char	gRTC_alarm_w_day;		// RTC A[ vddj or c`x

volatile unsigned char	rtc_1s_flg;				// qsbĂ鎞̂Pboߗp
volatile unsigned short	interval;				// Ԋui݊Ԋuj@OFo͂ȂAPFƁAQFƁARF
//*****************************************
// qsbG[
//*****************************************
void	rtc_error(void)
{
	// Ԃkdc𑬂_ł
	for(;;){
		led_red_on();				// LED ON
		delay_ms(100);				// 100mS Delay
		led_red_off();				// LED OFF
		delay_ms(100);				// 100mS Delay
	}
}

//*****************************************
// qwWXOO̗j̃f[^ɕϊ
//  w:0=sun --> 6=sat
// ߂l 0b00000001=sun --> 0b01000000=sat
//*****************************************
unsigned char	rx8900wday(unsigned char w)
{
	return(0x01 << w);
}

// *********************************************************
// cF[̌
//  FN 
// @@ F
// @@ F
// ߂l@jFOjAPjADDDDUyj
// *********************************************************
unsigned char	subZeller( unsigned short y, unsigned short m, unsigned short d )
{
	unsigned char	r;
	
    if( m < 3 ) {
        y--;
		m += 12;
    }
    r = (unsigned char)(( y + y/4 - y/100 + y/400 + ( 13*m + 8 )/5 + d )%7);
    return(r);
}


//***************************
// RTC(RX8900) Initial
//  qsb̏ݒ
//***************************
unsigned char	rtc_init(void)
{
	unsigned char	r = 0;
	unsigned char	req_init=0;

	twi_init();


	// PbM͐ݒ
	//  PD3(INT3): Pulse In from RTC Square Wave Signal
	DDRD &= ~(1 << DDD3);					// Port-D Bit3 : Intput
	PORTD |= (1 << PD3);					// Port-D Bit3 pullup


	r = rtc_flag_read();					// RTC Frag Reg.ǂݏo
	if(r != 0){
		return(r);
	}

	if((gRTC_flag & RTC_FL_B_VLF)!=0){		// dāAU~
		req_init=2;
	}else if((gRTC_flag & RTC_FL_B_VDET)!=0){	// UH̉x␳~܂Ă鎞
		req_init=1;
	}

	if(req_init == 2){							// VLF:1
		gRTC_extension = (RTC_EXT_B_TSEL1 | RTC_EXT_B_FSEL1);	// RTC GNXeV WX^ XV݁FbXVA^C}[\[XFbグANbNóF1Hz
		r = rtc_extension_write();
		if(r != 0){
			return(r);
		}

		gRTC_flag = 0x00;						// tOf[^NA
		r = rtc_flag_write();
		if(r != 0){
			return(r);
		}

		gRTC_control = (RTC_CONT_B_CSEL0 | RTC_CONT_B_UIE);		// RTC Rg[ WX^ xۏFQbAXV݉A^C}[ݕsAA[ݕs
		r = rtc_control_write();
		if(r != 0){
			return(r);
		}

		gRTC_sec  = 0x00;						// qsb b̃f[^ (BCD 0--59)
		gRTC_min  = 0x59;						// qsb ̃f[^ (BCD 0--59)
		gRTC_hou  = 0x23;						// qsb ̃f[^ (BCD 0--23j
		gRTC_wday = 0x07;						// qsb j̃f[^ (BCD 1--7)
		gRTC_day  = 0x31;						// qsb ̃f[^ (BCD 1--31)
		gRTC_mon  = 0x12;						// qsb ̃f[^ (BCD 1--12j
		gRTC_year = 0x22;						// qsb Ñf[^ (BCD 0--99)
		r = rtc_write_with_reset();				// RTC N 
		if(r != 0){
			return(r);
		}
		gReq_time_set = 1;						// 1= Time Set (RTC Data Break)

	}else if(req_init == 1){					// VDET:1
		gRTC_flag = 0x00;						// tOf[^NA
		r = rtc_flag_write();
		if(r != 0){
			return(r);
		}
	}

	// INT0 Interrupt Initial
//	rtc_1s_flg = 0;								// qsbĂ鎞̂Pboߗp
//	EICRA |=  (1 << ISC01);						// INT0 Falling Edge Interrupt
//	EICRA &= ~(1 << ISC00);						// INT0 Falling Edge Interrupt
//	EIMSK |= (1 << INT0);						// INT0 Interrupt Enable

	// INT3 Interrupt Initial
	rtc_1s_flg = 0;								// qsbĂ鎞̂Pboߗp
	EICRA |=  (1 << ISC31);						// INT3 Falling Edge Interrupt
	EICRA &= ~(1 << ISC30);						// INT3 Falling Edge Interrupt
	EIMSK |= (1 << INT3);						// INT3 Interrupt Enable

	return(0);
}

//***************************
// RTC ǂݏof[^NA
//***************************
void	rtc_read_data_clear(void)
{
	gRTC_sec = 0;						// qsb b̃f[^ (BCD 0--59)
	gRTC_min = 0;						// qsb ̃f[^ (BCD 0--59)
	gRTC_hou = 0;						// qsb ̃f[^ (BCD 0--23j
	gRTC_wday = 1;						// qsb j̃f[^ (BCD 1--7)
	gRTC_day = 1;						// qsb ̃f[^ (BCD 1--31)
	gRTC_mon = 1;						// qsb ̃f[^ (BCD 1--12j
	gRTC_year = 0;						// qsb Ñf[^ (BCD 0--99)
}

//***************************
// RTC N ǂݏo
//  ǂݏof[^͈ȉ̕ϐɓ
//	unsigned char	gRTC_sec;				// qsb b̃f[^ (BCD 0--59)
//	unsigned char	gRTC_min;				// qsb ̃f[^ (BCD 0--59)
//	unsigned char	gRTC_hou;				// qsb ̃f[^ (BCD 0--23j
//	unsigned char	gRTC_wday;				// qsb j̃f[^ (BCD 1--7)
//	unsigned char	gRTC_day;				// qsb ̃f[^ (BCD 1--31)
//	unsigned char	gRTC_mon;				// qsb ̃f[^ (BCD 1--12j
//	unsigned char	gRTC_year;				// qsb Ñf[^ (BCD 0--99)
//***************************
unsigned char rtc_read(void)
{
	unsigned char	data;
	unsigned char	r;

	r = twi_start(RX8900_ADDR,TW_WRITE);			// TWI Jn foCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_WRITE;
		rtc_read_data_clear();						// RTC ǂݏof[^NA
		return(r);
	}
	r = twi_write(0x00);							// TWI  iǏoJnAhXށj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		rtc_read_data_clear();						// RTC ǂݏof[^NA
		return(r);
	}
	twi_stop();


	r = twi_start(RX8900_ADDR,TW_READ);				// TWI Jn foCXAhXƂqd`c
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_READ;
		rtc_read_data_clear();						// RTC ǂݏof[^NA
		return(r);
	}
	r = twi_read(&data,ACK);						// TWI ǂݏoiŏ̃AhXbj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		rtc_read_data_clear();						// RTC ǂݏof[^NA
		return(r);
	}
	gRTC_sec = data;								// qsb b̃f[^ (BCD 0--59)

	r = twi_read(&data,ACK);						// TWI ǂݏoiQԖڂ̃AhXj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		rtc_read_data_clear();						// RTC ǂݏof[^NA
		return(r);
	}
	gRTC_min = data;								// qsb ̃f[^ (BCD 0--59)

	r = twi_read(&data,ACK);						// TWI ǂݏoiRԖڂ̃AhXj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		rtc_read_data_clear();						// RTC ǂݏof[^NA
		return(r);
	}
	gRTC_hou = data;								// qsb ̃f[^ (BCD 0--23j

	r = twi_read(&data,ACK);						// TWI ǂݏoiSԖڂ̃AhXjj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		rtc_read_data_clear();						// RTC ǂݏof[^NA
		return(r);
	}
	gRTC_wday = data;								// qsb j̃f[^ (BCD 1--7)

	r = twi_read(&data,ACK);						// TWI ǂݏoiTԖڂ̃AhXj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		rtc_read_data_clear();						// RTC ǂݏof[^NA
		return(r);
	}
	gRTC_day = data;								// qsb ̃f[^ (BCD 1--31)

	r = twi_read(&data,ACK);						// TWI ǂݏoiUԖڂ̃AhXj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		rtc_read_data_clear();						// RTC ǂݏof[^NA
		return(r);
	}
	gRTC_mon = data;								// qsb ̃f[^ (BCD 1--12j

	r = twi_read(&data,NACK);						// TWI ǂݏo Ō NACK=0 iVԖڂ̃AhXNj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		rtc_read_data_clear();						// RTC ǂݏof[^NA
		return(r);
	}
	gRTC_year = data;								// qsb Ñf[^ (BCD 0--99)

	twi_stop();

	return(r);
}

//***************************
// RTC N 
//  ݃f[^͈ȉ̕ϐɓĂ镨Ƃ
//	unsigned char	gRTC_sec;				// qsb b̃f[^ (BCD 0--59)
//	unsigned char	gRTC_min;				// qsb ̃f[^ (BCD 0--59)
//	unsigned char	gRTC_hou;				// qsb ̃f[^ (BCD 0--23j
//	unsigned char	gRTC_wday;				// qsb j̃f[^ (BCD 1--7)
//	unsigned char	gRTC_day;				// qsb ̃f[^ (BCD 1--31)
//	unsigned char	gRTC_mon;				// qsb ̃f[^ (BCD 1--12j
//	unsigned char	gRTC_year;				// qsb Ñf[^ (BCD 0--99)
//***************************
unsigned char	rtc_write(void)
{
	unsigned char	r;

	gRTC_sec &= 0x7F;
	r=twi_start(RX8900_ADDR,TW_WRITE);				// TWI Jn foCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r=twi_write(0x00);								// TWI  AhX
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	r=twi_write(gRTC_sec);							// b̃f[^ (BCD 0--59)
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	r=twi_write(gRTC_min);							// ̃f[^ (BCD 0--59)
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	r=twi_write(gRTC_hou);							// ̃f[^ (BCD 0--23j
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	r=twi_write(gRTC_wday);							// j̃f[^ (BCD 1--7)
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	r=twi_write(gRTC_day);							// ̃f[^ (BCD 1--31)
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	r=twi_write(gRTC_mon);							// ̃f[^ (BCD 1--12j
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	r=twi_write(gRTC_year);							// Ñf[^ (BCD 0--99)
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	twi_stop();

	return(r);
}

//***************************
// RTC N  Zbgrbg𗧂ĂĂ珑
//  ݃f[^͈ȉ̕ϐɓĂ镨Ƃ
//	unsigned char	gRTC_sec;				// qsb b̃f[^ (BCD 0--59)
//	unsigned char	gRTC_min;				// qsb ̃f[^ (BCD 0--59)
//	unsigned char	gRTC_hou;				// qsb ̃f[^ (BCD 0--23j
//	unsigned char	gRTC_wday;				// qsb j̃f[^ (BCD 1--7)
//	unsigned char	gRTC_day;				// qsb ̃f[^ (BCD 1--31)
//	unsigned char	gRTC_mon;				// qsb ̃f[^ (BCD 1--12j
//	unsigned char	gRTC_year;				// qsb Ñf[^ (BCD 0--99)
//***************************
unsigned char	rtc_write_with_reset(void)
{
	unsigned char	r;

	r = rtc_control_read();							// RTC Rg[f[^ǂݏo
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}
	gRTC_control |= RTC_CONT_B_RESET;				// Reset Bit ON

	gRTC_sec &= 0x7F;
	r=twi_start(RX8900_ADDR,TW_WRITE);				// TWI Jn foCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r=twi_write(RTC_CONTROL_ADDR);					// TWI  AhX(0x0f)
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	r=twi_write(gRTC_control);						// Rg[f[^ (Reset Bit ON)
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	r=twi_write(gRTC_sec);							// b̃f[^ (BCD 0--59)
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	r=twi_write(gRTC_min);							// ̃f[^ (BCD 0--59)
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	r=twi_write(gRTC_hou);							// ̃f[^ (BCD 0--23j
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	r=twi_write(gRTC_wday);							// j̃f[^ (BCD 1--7)
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	r=twi_write(gRTC_day);							// ̃f[^ (BCD 1--31)
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	r=twi_write(gRTC_mon);							// ̃f[^ (BCD 1--12j
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	r=twi_write(gRTC_year);							// Ñf[^ (BCD 0--99)
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	twi_stop();

	return(r);
}

//***************************
// RTC GNXeV WX^ǂݏo
//***************************
unsigned char	rtc_extension_read(void)
{
	unsigned char	data;
	unsigned char	r;

	r = twi_start(RX8900_ADDR,TW_WRITE);			// TWI Jn foCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r = twi_write(RTC_EXTENSION_ADDR);				// TWI  iǏoJnAhXށj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}
	twi_stop();

	r = twi_start(RX8900_ADDR,TW_READ);				// TWI Jn foCXAhXƂqd`c
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_READ;
		return(r);
	}

	r = twi_read(&data,NACK);						// TWI ǂݏo Ō NACK=0
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_extension = data;							// qsb GNXeṼf[^

	twi_stop();

	return(0);

}

//***************************
// RTC tOǂݏo
//***************************
unsigned char	rtc_flag_read(void)
{
	unsigned char	data;
	unsigned char	r;

	r = twi_start(RX8900_ADDR,TW_WRITE);			// TWI Jn foCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r = twi_write(RTC_FLAG_ADDR);					// TWI  iǏoJnAhXށj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}
	twi_stop();

	r = twi_start(RX8900_ADDR,TW_READ);				// TWI Jn foCXAhXƂqd`c
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_READ;
		return(r);
	}

	r = twi_read(&data,NACK);						// TWI ǂݏo Ō NACK=0
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_flag = data;							// qsb tÕf[^

	twi_stop();

	return(0);
}

//***************************
// RTC Rg[f[^ǂݏo
//***************************
unsigned char	rtc_control_read(void)
{
	unsigned char	data;
	unsigned char	r;

	r = twi_start(RX8900_ADDR,TW_WRITE);			// TWI Jn foCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r = twi_write(RTC_CONTROL_ADDR);				// TWI  iǏoJnAhXށj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}
	twi_stop();

	r = twi_start(RX8900_ADDR,TW_READ);				// TWI Jn foCXAhXƂqd`c
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_READ;
		return(r);
	}

	r = twi_read(&data,NACK);						// TWI ǂݏo Ō NACK=0
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_control = data;							// qsb tÕf[^

	twi_stop();

	return(0);
}

//***************************
// RTC xf[^ǂݏo
//***************************
unsigned char	rtc_tempe_read(void)
{
	unsigned char	data;
	unsigned char	r;

	r = twi_start(RX8900_ADDR,TW_WRITE);			// TWI Jn foCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r = twi_write(RTC_TEMPE_ADDR);					// TWI  iǏoJnAhXށj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}
	twi_stop();

	r = twi_start(RX8900_ADDR,TW_READ);				// TWI Jn foCXAhXƂqd`c
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_READ;
		return(r);
	}

	r = twi_read(&data,NACK);						// TWI ǂݏo Ō NACK=0
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_tempe = data;								// qsb x̃f[^

	twi_stop();

	return(0);
}

//***************************
// RTC obNAbvf[^ǂݏo
//***************************
unsigned char	rtc_buckup_read(void)
{
	unsigned char	data;
	unsigned char	r;

	r = twi_start(RX8900_ADDR,TW_WRITE);			// TWI Jn foCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r = twi_write(RTC_BACKUP_ADDR);					// TWI  iǏoJnAhXށj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}
	twi_stop();

	r = twi_start(RX8900_ADDR,TW_READ);				// TWI Jn foCXAhXƂqd`c
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_READ;
		return(r);
	}

	r = twi_read(&data,NACK);						// TWI ǂݏo Ō NACK=0
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_buckup = data;								// qsb obNAbṽf[^

	twi_stop();

	return(0);
}

//***************************
// RTC ^C}[JE^[f[^ǂݏo
//***************************
unsigned char	rtc_timer_count_read(void)
{
	unsigned char	data;
	unsigned char	r;

	r = twi_start(RX8900_ADDR,TW_WRITE);			// TWI Jn foCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r = twi_write(RTC_TIM_COUNT_ADDR);				// TWI  iǏoJnAhXށj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}
	twi_stop();

	r = twi_start(RX8900_ADDR,TW_READ);				// TWI Jn foCXAhXƂqd`c
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_READ;
		return(r);
	}
	r = twi_read(&data,ACK);						// TWI ǂݏo
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_timer_count0 = data;						// RTC ^C}[JE^[O

	r = twi_read(&data,NACK);						// TWI ǂݏo Ō NACK=0
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_timer_count1 = data;						// RTC ^C}[JE^[P

	twi_stop();

	return(0);
}

//***************************
// RTC A[f[^ ǂݏo
//***************************
unsigned char	rtc_timer_alarm_read(void)
{
	unsigned char	data;
	unsigned char	r;

	r = twi_start(RX8900_ADDR,TW_WRITE);			// TWI Jn foCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r = twi_write(RTC_ALARM_ADDR);				// TWI  iǏoJnAhXށj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}
	twi_stop();

	r = twi_start(RX8900_ADDR,TW_READ);				// TWI Jn foCXAhXƂqd`c
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_READ;
		return(r);
	}
	r = twi_read(&data,ACK);						// TWI ǂݏo
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_alarm_min = data;							// RTC A[ lhm

	r = twi_read(&data,ACK);						// TWI ǂݏo
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_alarm_hou = data;							// RTC A[ gntq

	r = twi_read(&data,NACK);						// TWI ǂݏo Ō NACK=0
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_alarm_w_day = data;						// RTC A[ vddj or c`x

	twi_stop();

	return(0);
}
//***************************
// RTC GNXeV WX^ 
//***************************
unsigned char	rtc_extension_write(void)
{
	unsigned char	r;

	r = twi_start(RX8900_ADDR,TW_WRITE);			// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r = twi_write(RTC_EXTENSION_ADDR);				// TWI  AhX
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	r = twi_write(gRTC_extension);					// RTC GNXeV WX^
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	twi_stop();

	return(r);
}
//***************************
// RTC tO 
//***************************
unsigned char	rtc_flag_write(void)
{
	unsigned char	r;

	r = twi_start(RX8900_ADDR,TW_WRITE);			// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r = twi_write(RTC_FLAG_ADDR);					// TWI  AhX
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	r = twi_write(gRTC_flag);						// RTC tO
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	twi_stop();

	return(r);
}

//***************************
// RTC Rg[f[^ 
//***************************
unsigned char	rtc_control_write(void)
{
	unsigned char	r;

	r = twi_start(RX8900_ADDR,TW_WRITE);			// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r = twi_write(RTC_CONTROL_ADDR);				// TWI  AhX
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	r = twi_write(gRTC_control);					// RTC Rg[f[^
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	twi_stop();

	return(r);
}

//***************************
// RTC obNAbvf[^ 
//***************************
unsigned char	rtc_buckup_write(void)
{
	unsigned char	r;

	r = twi_start(RX8900_ADDR,TW_WRITE);			// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r = twi_write(RTC_BACKUP_ADDR);					// TWI  AhX
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	r = twi_write(gRTC_buckup);						// RTC obNAbvf[^
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	twi_stop();

	return(r);
}

//***************************
// RTC ^C}[JE^[f[^
//***************************
unsigned char	rtc_timer_count_write(void)
{
	unsigned char	r;

	r = twi_start(RX8900_ADDR,TW_WRITE);			// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r = twi_write(RTC_TIM_COUNT_ADDR);				// TWI  AhX
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}
	r = twi_write(gRTC_timer_count0);				// RTC ^C}[JE^[O
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}
	r = twi_write(gRTC_timer_count1);				// RTC ^C}[JE^[P
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	twi_stop();

	return(r);
}

//***************************
// RTC A[f[^ 
//***************************
unsigned char	rtc_timer_alarm_write(void)
{
	unsigned char	r;

	r = twi_start(RX8900_ADDR,TW_WRITE);			// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r = twi_write(RTC_ALARM_ADDR);					// TWI  AhX
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}
	r = twi_write(gRTC_alarm_min);					// RTC A[ lhm
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}
	r = twi_write(gRTC_alarm_hou);					// RTC A[ gntq
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	r = twi_write(gRTC_alarm_w_day);				// RTC A[ vddj or c`x
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	twi_stop();

	return(r);
}

//***************************
// RTC SẴWX^f[^ǂݏo
//  ǂݏof[^ gRTC_reg[16] ɓ
//
//	RX8900_ADDR		0x64	// I2C RX8025 Device Address
//  TW_READ			1
//  TW_WRITE		0
//
//***************************
unsigned char	rtc_all_register_read(void)
{
	unsigned char	data;
	unsigned char	r;

	r = twi_start(RX8900_ADDR,TW_WRITE);			// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r = twi_write(0x00);							// TWI  iǏoJnAhXށj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}
	twi_stop();

	r = twi_start(RX8900_ADDR,TW_READ);				// TWI Jn foCXhcƃfoCXAhXƂqd`c
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_READ;
		return(r);
	}

	r = twi_read(&data,ACK);						// TWI ǂݏoiAhX@OOOj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[0] = data;								// qsb ŏ̃AhX̃f[^

	r = twi_read(&data,ACK);						// TWI ǂݏoiAhX@OOPj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[1] = data;								// qsb QԖڂ̃AhX̃f[^

	r = twi_read(&data,ACK);						// TWI ǂݏoiAhX@OOQj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[2] = data;								// qsb RԖڂ̃AhX̃f[^

	r = twi_read(&data,ACK);						// TWI ǂݏoiAhX@OORj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[3] = data;								// qsb SԖڂ̃AhX̃f[^

	r = twi_read(&data,ACK);						// TWI ǂݏoiAhX@OOSj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[4] = data;								// qsb TԖڂ̃AhX̃f[^

	r = twi_read(&data,ACK);						// TWI ǂݏoiAhX@OOTj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[5] = data;								// qsb UԖڂ̃AhX̃f[^

	r = twi_read(&data,ACK);						// TWI ǂݏoiAhX@OOUj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[6] = data;								// qsb VԖڂ̃AhX̃f[^

	r = twi_read(&data,ACK);						// TWI ǂݏoiAhX@OOVj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[7] = data;								// qsb WԖڂ̃AhX̃f[^

	r = twi_read(&data,ACK);						// TWI ǂݏoiAhX@OOWj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[8] = data;								// qsb XԖڂ̃AhX̃f[^

	r = twi_read(&data,ACK);						// TWI ǂݏoiAhX@OOXj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[9] = data;								// qsb POԖڂ̃AhX̃f[^

	r = twi_read(&data,ACK);						// TWI ǂݏoiAhX@OO`j
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[10] = data;							// qsb PPԖڂ̃AhX̃f[^

	r = twi_read(&data,ACK);						// TWI ǂݏoiAhX@OOaj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[11] = data;							// qsb PQԖڂ̃AhX̃f[^

	r = twi_read(&data,ACK);						// TWI ǂݏoiAhX@OObj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[12] = data;							// qsb PRԖڂ̃AhX̃f[^

	r = twi_read(&data,ACK);						// TWI ǂݏoiAhX@OOcj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[13] = data;							// qsb PSԖڂ̃AhX̃f[^


	r = twi_read(&data,ACK);						// TWI ǂݏoiAhX@OOdj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[14] = data;							// qsb PTԖڂ̃AhX̃f[^

	r = twi_read(&data,NACK);						// TWI ǂݏo Ō NACK=0
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[15] = data;							// qsb PUԖڂ̃AhX̃f[^

	twi_stop();


	return(0);
}

//*****************************************
// INT0 Interrupt
//  Start Bit Falling Edge Sence
// 	qsb@^hmsM
//  \߁@qsb̏ݒłPbo͂ɐݒ肷邱
//*****************************************
ISR (INT0_vect)
{
//	rtc_1s_flg++;								// qsbĂ鎞̂Pboߗp

}
//*****************************************
// INT3 Interrupt
//  Start Bit Falling Edge Sence
// 	qsb@^hmsM
//  \߁@qsb̏ݒłPbo͂ɐݒ肷邱
//*****************************************
ISR (INT3_vect)
{
	rtc_1s_flg++;								// qsbĂ鎞̂Pboߗp

}
