//*****************************************
// Photo Box with ATmega64 or Atmega2560
// CPU Clock:O16MHz Ext,Crystal 16MHz)
//   iq[Yf[^@WȂŊOUɂj
//
// File Name:Rtc_Rx8900_h.h
//  wb_[t@C
//
// Real Time Clock Rx8900
//
//
//  2012/11/12 New Taishi
//  2023/05/16 Modify for mega328_iic_oled_rtc Taishi
//  2023/12/09 Modify for Photo Box with ATmega64 Taishi
//  2024/01/09 Modify for Photo Box with ATmega64 or ATmega2560 Taishi
//*****************************************

#define RX8900_ADDR		0x64					// I2C RX8025 foCXAhXiʂSrbg̓̏RrbgAcP`cRj

#define	RTC_ERR_TWI_START_TW_WRITE	1
#define	RTC_ERR_TWI_WRITE			2
#define	RTC_ERR_TWI_START_TW_READ	3
#define	RTC_ERR_TWI_READ			4

volatile extern	unsigned char	gRTC_sec;				// qsb b̃f[^ (BCD 0--59)
volatile extern	unsigned char	gRTC_min;				// qsb ̃f[^ (BCD 0--59)
volatile extern	unsigned char	gRTC_hou;				// qsb ̃f[^ (BCD 0--23j
volatile extern	unsigned char	gRTC_wday;				// qsb j̃f[^ (BCD 1--7)
volatile extern	unsigned char	gRTC_day;				// qsb ̃f[^ (BCD 1--31)
volatile extern	unsigned char	gRTC_mon;				// qsb ̃f[^ (BCD 1--12j
volatile extern	unsigned char	gRTC_year;				// qsb Ñf[^ (BCD 0--99)
volatile extern	unsigned char	gRTC_control1;			// qsb Rg[P̃f[^
volatile extern	unsigned char	gRTC_control2;			// qsb Rg[Q̃f[^
volatile extern	unsigned char	gRTC_control1_first;	// qsb Nŏ̃Rg[P̃f[^
volatile extern	unsigned char	gRTC_control2_first;	// qsb Nŏ̃Rg[Q̃f[^
volatile extern	unsigned char	gRTC_reg[16];			// SẴWX^̒l0x00<-->0x0f (wuthout 0x17<-->0x1a)

volatile extern	unsigned char	gRTC_extension;			// RTC GNXeV WX^
volatile extern	unsigned char	gRTC_flag;				// RTC tO
volatile extern	unsigned char	gRTC_control;			// RTC Rg[f[^
volatile extern	unsigned char	gRTC_tempe;				// RTC xf[^
volatile extern	unsigned char	gRTC_buckup;			// RTC obNAbvf[^
volatile extern	unsigned char	gRTC_timer_count0;		// RTC ^C}[JE^[O
volatile extern	unsigned char	gRTC_timer_count1;		// RTC ^C}[JE^[P
volatile extern	unsigned char	gRTC_alarm_min;			// RTC A[ lhm
volatile extern	unsigned char	gRTC_alarm_hou;			// RTC A[ gntq
volatile extern	unsigned char	gRTC_alarm_w_day;		// RTC A[ vddj or c`x

volatile extern	unsigned short	interval;				// Ԋui݊Ԋuj@OFo͂ȂAPFƁAQFƁARF

#define	RTC_ALARM_ADDR		0x08				// A[̂qsb擪AhX
#define	RTC_TIM_COUNT_ADDR	0x0b				// ^C}[JE^[̂qsb擪AhX

// ****** Extension Reg. *******
#define	RTC_EXTENSION_ADDR	0x0d				// GNXeV̂qsbAhX
#define	RTC_EXT_B_TSEL0		0x01				// GNXeV̂srdkOrbg
#define	RTC_EXT_B_TSEL1		0x02				// GNXeV̂srdkPrbg
#define	RTC_EXT_B_FSEL0		0x04				// GNXeV̂erdkOrbg
#define	RTC_EXT_B_FSEL1		0x08				// GNXeV̂erdkPrbg
#define	RTC_EXT_B_TE		0x10				// GNXeV̂sdrbg
#define	RTC_EXT_B_USEL		0x20				// GNXeV̂trdkrbg
#define	RTC_EXT_B_WADA		0x40				// GNXeV̂v`c`rbg
#define	RTC_EXT_B_TEST		0x80				// GNXeV̂sdrsrbg
// *****************************


// ********* Flag Reg. *********
#define	RTC_FLAG_ADDR		0x0e				// tÔqsbAhX
#define	RTC_FL_B_VDET		0x01				// tÔucdsrbg
#define	RTC_FL_B_VLF		0x02				// tÔukerbg
#define	RTC_FL_B_AF			0x08				// tÔ`erbg
#define	RTC_FL_B_TF			0x10				// tÔserbg
#define	RTC_FL_B_UF			0x20				// tÔterbg
// *****************************


// ******** Control Reg. *******
#define	RTC_CONTROL_ADDR	0x0f				// Rg[̂qsbAhX
#define	RTC_CONT_B_RESET	0x01				// Rg[̂qdrdsrbg
#define	RTC_CONT_B_AIE		0x08				// Rg[̂`hdrbg
#define	RTC_CONT_B_TIE		0x10				// Rg[̂shdrbg
#define	RTC_CONT_B_UIE		0x20				// Rg[̂thdrbg
#define	RTC_CONT_B_CSEL0	0x40				// Rg[̂brdkOrbg
#define	RTC_CONT_B_CSEL1	0x80				// Rg[̂brdkPrbg
// *****************************

// ******** Tempe Reg. *********
#define	RTC_TEMPE_ADDR		0x17				// x̂qsbAhX
#define	RTC_TEMPE_B_1		0x01				// x̂Prbg
#define	RTC_TEMPE_B_2		0x02				// x̂Qrbg
#define	RTC_TEMPE_B_4		0x04				// x̂Srbg
#define	RTC_TEMPE_B_8		0x08				// x̂Wrbg
#define	RTC_TEMPE_B_16		0x10				// x̂PUrbg
#define	RTC_TEMPE_B_32		0x20				// x̂RQrbg
#define	RTC_TEMPE_B_64		0x40				// x̂USrbg
#define	RTC_TEMPE_B_128		0x80				// x̂PQWrbg
// *****************************


// ******* Backup Reg. *********
#define	RTC_BACKUP_ADDR		0x18				// obNAbv̂qsbAhX
#define	RTC_BAK_B_BKSMP2	0x01				// obNAbv̂ajrloQrbg
#define	RTC_BAK_B_BKSMP1	0x02				// obNAbv̂ajrloPrbg
#define	RTC_BAK_B_SWOFF		0x04				// obNAbv̂rvneerbg
#define	RTC_BAK_B_VDETOFF	0x08				// obNAbv̂ucdsneerbg
// *****************************

volatile extern	unsigned char	rtc_1s_flg;				// qsbĂ鎞̂Pboߗp



extern	unsigned char	rtc_init(void);
extern	unsigned char	rtc_read(void);
extern	unsigned char	rtc_write(void);
extern	unsigned char	rtc_write_with_reset(void);
extern	void			rtc_read_data_clear(void);
extern	unsigned char	rtc_all_register_read(void);

extern	unsigned char	rtc_extension_read(void);
extern	unsigned char	rtc_flag_read(void);
extern	unsigned char	rtc_control_read(void);
extern	unsigned char	rtc_tempe_read(void);
extern	unsigned char	rtc_buckup_read(void);
extern	unsigned char	rtc_timer_count_read(void);
extern	unsigned char	rtc_timer_alarm_read(void);

extern	unsigned char	rtc_extension_write(void);
extern	unsigned char	rtc_flag_write(void);
extern	unsigned char	rtc_control_write(void);
extern	unsigned char	rtc_buckup_read(void);
extern	unsigned char	rtc_timer_count_write(void);
extern	unsigned char	rtc_timer_alarm_write(void);

extern	void			rtc_error(void);
extern	unsigned char	rx8900wday(unsigned char w);
extern	unsigned char	subZeller( unsigned short y, unsigned short m, unsigned short d );

