//*****************************************
// Photo Box with ATmega64 or Atmega2560
// CPU Clock:O16MHz Ext,Crystal 16MHz)
//   iq[Yf[^@WȂŊOUɂj
//
// File Name:eep_dat.c
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/17 Modify for six IN-16 clock Taishi
//  2020/09/24 Modify for four IN-8 clock Taishi
//  2022/02/26 Modify for four IN-4 & ZM1020 clock Taishi
//  2022/04/09 Modify for four ZM1020 clock Taishi
//  2024/01/09 Modify for Photo Box with ATmega64 or ATmega2560 Taishi
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/eeprom.h>

#include	"pr_mega64_2560_photo_box_h.h"

#include	"oled_1306_h.h"
#include	"disp_8x48_dot_h.h"
#include	"port_bit_h.h"
#include	"timer_h.h"

#include	"eep_dat_h.h"

uint8_t	eep_wd EEMEM = 0;			// j\ۂ OF\Ȃ
uint8_t	eep_sd EEMEM = 0;			// j\̕bhbg\邩ۂ OF\Ȃ
static	unsigned short	eep_bfs[10];

//*****************************************
//  ddoqnl j\ۂ ǂݍ
//*****************************************
unsigned char	read_eep_wd(void)
{
	unsigned short	r = 0;

	eeprom_busy_wait();
	eep_bfs[0] = eeprom_read_byte(&eep_wd);		// Ǐo
	if((0 <= eep_bfs[0])&&(eep_bfs[0] <= 1)){
		r = eep_bfs[0];
	}else{
		r = 0;
	}

	return(r);
}

//*****************************************
//  ddoqnl j\ۂ 
//*****************************************
void	write_eep_wd(unsigned char uc)
{
	eep_bfs[0] = uc;
	eeprom_busy_wait();
	eeprom_write_byte(&eep_wd, eep_bfs[0]);		// 
	eeprom_busy_wait();
}
//*****************************************
//  ddoqnl bhbg\ۂ ǂݍ
//*****************************************
unsigned char	read_eep_sd(void)
{
	unsigned short	r = 0;

	eeprom_busy_wait();
	eep_bfs[0] = eeprom_read_byte(&eep_sd);		// Ǐo
	if((0 <= eep_bfs[0])&&(eep_bfs[0] <= 1)){
		r = eep_bfs[0];
	}else{
		r = 0;
	}

	return(r);
}

//*****************************************
//  ddoqnl bhbg\ۂ 
//*****************************************
void	write_eep_sd(unsigned char uc)
{
	eep_bfs[0] = uc;
	eeprom_busy_wait();
	eeprom_write_byte(&eep_sd, eep_bfs[0]);		// 
	eeprom_busy_wait();
}
//***************************
// j\ۂ̒lC
//  rdsXCb`ꂽ@݂̂vc̒lɏ݈Ȍケ̒lg
//***************************
#define		WD_POSX			(7*6)
void	edit_wd(void)
{
	unsigned short	us;
	unsigned char	swd;
	unsigned char	blk_stat=0;
	unsigned char	on_off[2]={'N','Y'};

	swd = gWd;

	get_sw();

	tim_10ms_blink = 50;							// uNp^C}[
	delay_ms(10);									// 10mS Delay
	get_sw();
	delay_ms(10);									// 10mS Delay
	get_sw();
	delay_ms(10);									// 10mS Delay

	led_red_off();									// LED OFF
	disp_8x48_G_5x7(0,(unsigned char *)("DofWek:"));
	disp_oled_G_12x16(0*6, 6*8, (unsigned char *)("  DofWek:  "));		// x, y, data(12x16)
	asc_to_rotate90(WD_POSX,on_off[swd],0);
	disp_one_char_oled_G_12x16(9*12, 6*8, on_off[swd]);
	delay_ms(1000);									// 1S Delay
	wait_key_off();									// Q̃XCb`Q@܂

	for(;;){
		us = get_action_sw();						// XCb`Ԃ
		us &= SW_MASK;								// XCb`ɂ

		if(us == SW1_OFF_LONG){						// XCb`ėꂽ(set switch)
			cli();
			write_eep_wd(swd);						// ddoqnl wd 
			sei();									// 荞݉
			led_red_on();							// LED ON
			asc_to_rotate90(WD_POSX,on_off[swd],0);
			disp_one_char_oled_G_12x16(9*12, 6*8, on_off[swd]);
			delay_ms(1000);							// 1000mS Delay
			led_red_off();							// LED OFF
			gWd = swd;
			break;									// ddoqnlɕۑďI
		}else if(us == SW1_OFF_SHORT){				// Zꂽ(set switch)
			break;									// ȂŏI
		}else if(us == SW2_OFF_SHORT){				// Zꂽ(select switch)
			if(swd == 0){
				swd = 1;
			}else{
				swd = 0;
			}
			tim_10ms_blink = 50;
			blk_stat = 0;
			asc_to_rotate90(WD_POSX,on_off[swd],0);
			disp_one_char_oled_G_12x16(9*12, 6*8, on_off[swd]);
		}
		if(tim_10ms_blink == 0){
			tim_10ms_blink = 50;
			if(blk_stat==0){
				blk_stat = 1;
				asc_to_rotate90(WD_POSX,' ',0);
				disp_one_char_oled_G_12x16(9*12, 6*8, ' ');
			}else{
				blk_stat = 0;
				asc_to_rotate90(WD_POSX,on_off[swd],0);
				disp_one_char_oled_G_12x16(9*12, 6*8, on_off[swd]);
			}
		}

	}
}

//***************************
// bhbg\ۂ̒lC
//  rdsXCb`ꂽ@݂̂rc̒lɏ݈Ȍケ̒lg
//***************************
#define		SD_POSX			(7*6)
void	edit_sd(void)
{
	unsigned short	us;
	unsigned char	ssd;
	unsigned char	blk_stat=0;
	unsigned char	on_off[2]={'N','Y'};

	ssd = gSd;

	get_sw();

	tim_10ms_blink = 50;							// uNp^C}[
	delay_ms(10);									// 10mS Delay
	get_sw();
	delay_ms(10);									// 10mS Delay
	get_sw();
	delay_ms(10);									// 10mS Delay

	led_red_off();									// LED OFF
	disp_8x48_G_5x7(0,(unsigned char *)("DotSsc:"));
	asc_to_rotate90(SD_POSX,on_off[ssd],0);
	disp_oled_G_12x16(0*6, 6*8, (unsigned char *)("  DotSec:  "));		// x, y, data(12x16)
	disp_one_char_oled_G_12x16(9*12, 6*8, on_off[ssd]);
	delay_ms(1000);									// 1S Delay
	wait_key_off();									// Q̃XCb`Q@܂

	for(;;){
		us = get_action_sw();						// XCb`Ԃ
		us &= SW_MASK;								// XCb`ɂ

		if(us == SW1_OFF_LONG){						// XCb`ėꂽ(set switch)
			cli();
			write_eep_sd(ssd);						// ddoqnl wd 
			sei();									// 荞݉
			led_red_on();							// LED ON
			asc_to_rotate90(SD_POSX,on_off[ssd],0);
			disp_one_char_oled_G_12x16(9*12, 6*8, on_off[ssd]);
			delay_ms(1000);							// 1000mS Delay
			led_red_off();							// LED OFF
			gSd = ssd;
			break;									// ddoqnlɕۑďI
		}else if(us == SW1_OFF_SHORT){				// Zꂽ(set switch)
			break;									// ȂŏI
		}else if(us == SW2_OFF_SHORT){				// Zꂽ(select switch)
			if(ssd == 0){
				ssd = 1;
			}else{
				ssd = 0;
			}
			tim_10ms_blink = 50;
			blk_stat = 0;
			asc_to_rotate90(SD_POSX,on_off[ssd],0);
			disp_one_char_oled_G_12x16(9*12, 6*8, on_off[ssd]);
		}
		if(tim_10ms_blink == 0){
			tim_10ms_blink = 50;
			if(blk_stat==0){
				blk_stat = 1;
				asc_to_rotate90(SD_POSX,' ',0);
				disp_one_char_oled_G_12x16(9*12, 6*8, ' ');
			}else{
				blk_stat = 0;
				asc_to_rotate90(SD_POSX,on_off[ssd],0);
				disp_one_char_oled_G_12x16(9*12, 6*8, on_off[ssd]);
			}
		}

	}
}
