//*****************************************
// Photo Box with ATmega64 or Atmega2560
// CPU Clock:O16MHz Ext,Crystal 16MHz)
//   iq[Yf[^@WȂŊOUɂj
//
// File Name:timer_h.h
//  wb_[t@C
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/01 Modify for pr_mega1284_8x8dot_clock Taishi
//  2022/10/10 add day_of_week Display Taishi
//  2023/03/07 Modify for mega328_i2c_old Taishi
//  2023/05/13 Modify for mega328_iic_oled_rtc Taishi
//  2023/12/09 Modify for Photo Box with ATmega64 Taishi
//  2024/01/09 Modify for Photo Box with ATmega64 or ATmega2560 Taishi
//*****************************************

extern	void	delay_2us(unsigned char t);
extern	void	delay_ms(int tm);

// ************************ Timer 1 *************************
extern	void	timer1_init(void);
extern	void	timer1_close(void);

#ifdef	cpu64
// ******************* Timer 2 (16MHz) ***********************
// 1000uS(1mS) Interrupt
#define		COUNT_1MS			250											// 1mS at 16MHz/64 = 250kHz(4uS)
#define		D_TCCR2_1000		((0 << CS22) | (1 << CS21) | (1 << CS20))	// Timer Start (16MHz/64 = 250kHz, 4uS)
#define		VAL_FOR_10MS_1000	10											// ݎ10mSPʂl

// 500uS Interrupt
#define		COUNT_05MS			125											// 0.5mS at 16MHz/64 = 250kHz(4uS)
#define		D_TCCR2_500			((0 << CS22) | (1 << CS21) | (1 << CS20))	// Timer Start (16MHz/64 = 250kHz, 4uS)
#define		VAL_FOR_10MS_500	20											// ݎ10mSPʂl

// 200uS Interrupt
#define		COUNT_02MS			50											// 0.25mS at 16MHz/64 = 250kHz(4uS)
#define		D_TCCR2_200			((0 << CS22) | (1 << CS21) | (1 << CS20))	// Timer Start (16MHz/64 = 250kHz, 4uS)
#define		VAL_FOR_10MS_200	50											// ݎ10mSPʂl

// 100uS Interrupt
#define		COUNT_01MS			25											// 0.1mS at 16MHz/64 = 250kHz(4uS)
#define		D_TCCR2_100			((0 << CS22) | (1 << CS21) | (1 << CS20))	// Timer Start (16MHz/64 = 250kHz, 4uS)
#define		VAL_FOR_10MS_100	100											// ݎ10mSPʂl
#else
 #ifdef cpu2560
// ******************* Timer 2 (16MHz) ***********************
// 1000uS(1mS) Interrupt
#define		COUNT_1MS			250											// 1mS at 16MHz/64 = 250kHz(4uS)
#define		D_TCCR2_1000		((1 << CS22) | (0 << CS21) | (0 << CS20))	// Timer Start (16MHz/64 = 250kHz, 4uS)
#define		VAL_FOR_10MS_1000	10											// ݎ10mSPʂl

// 500uS Interrupt
#define		COUNT_05MS			125											// 0.5mS at 16MHz/64 = 250kHz(4uS)
#define		D_TCCR2_500			((1 << CS22) | (0 << CS21) | (0 << CS20))	// Timer Start (16MHz/64 = 250kHz, 4uS)
#define		VAL_FOR_10MS_500	20											// ݎ10mSPʂl

// 200uS Interrupt
#define		COUNT_02MS			50											// 0.25mS at 16MHz/64 = 250kHz(4uS)
#define		D_TCCR2_200			((1 << CS22) | (0 << CS21) | (0 << CS20))	// Timer Start (16MHz/64 = 250kHz, 4uS)
#define		VAL_FOR_10MS_200	50											// ݎ10mSPʂl

// 100uS Interrupt
#define		COUNT_01MS			25											// 0.1mS at 16MHz/64 = 250kHz(4uS)
#define		D_TCCR2_100			((1 << CS22) | (0 << CS21) | (0 << CS20))	// Timer Start (16MHz/64 = 250kHz, 4uS)
#define		VAL_FOR_10MS_100	100											// ݎ10mSPʂl

 #endif
#endif

#define		TIM_DISP_RETURN		20						// \ȊOő삪ɖ߂鎞ԁibj

extern	unsigned char	tim_10ms_sw;					// XCb`͗pPOrPʃ^C}[
extern	unsigned char	tim_10ms_sw1_length;			// XCb`PpԂPOrPʃ^C}[@|P
extern	unsigned char	tim_10ms_sw1_continue;			// XCb`PpAPOrPʃ^C}[@|P
extern	unsigned char	tim_10ms_sw2_length;			// XCb`QpԂPOrPʃ^C}[@|P
extern	unsigned char	tim_10ms_sw2_continue;			// XCb`QpAPOrPʃ^C}[@|P
extern	unsigned char	tim_1s_no_key_timeup;			// L[͂Ȃ̃^CAbvp
extern	unsigned char	tim_10ms_blink;					// \uNpPOrPʃ^C}[
extern	unsigned char	tim_10ms_anime;					// jLV[\̃^C~OpPOrPʃ^C}[
extern	unsigned char	tim_10ms_infrared;				// ԊORfqpPOrPʃ^C}[
extern	unsigned char	tim_10ms_beat;					// C[vmFpPOrPʃ^C}[
extern	unsigned char	tim_10ms_adget;					// `^cl擾pPOrPʃ^C}[
extern	void			timer2_init(void);
extern	void			timer2_close(void);
extern	unsigned char	proc_no_key_timeup(unsigned char on);
